'
'-- Web site checker - VBScript & IE Version
'
'-- (C) John Brock 2006 - john_brock@telkomsa.net
'   Modifications:
'	1 Added ability to write csv/text file for logging purposes.
'	2 Add ability to read a csv/text file of URL's to check. Obviates argument passing.
'
'
'
Option Explicit
'
Dim strTitle
Dim WshShell
Dim IEauto
Dim objDoc
'
Dim TimeNow, TimeEnd
Dim TimeTaken
'
Dim oArgs
Dim TextURL    


'-- Get the command line args
Set oArgs = Wscript.arguments
'
'-- If no command line arguments provided, 
'   prompt for input OR print Usage message
If oArgs.Count = 0 Then
'    Wscript.Echo "Usage: URL to check. "
'    TextURL = InputBox("We need to know the URL to check.", 64, "Input the URL you wish to check." )
Else
    '-- otherwise it was specified.
    TextURL = oArgs.item(0)
End If

'--
Set WshShell = Wscript.CreateObject("Wscript.Shell")
'--
WshShell.PopUp  "Website checker program [prototype] - (C) John Brock 2006", 2, "Web Page access checker."
'-- ProgID
Set IEauto = CreateObject("InternetExplorer.application")
'--
If len(TextURL) > 1 then CheckWebSite TextURL
'
'-- Change these to set new or other web sites.                               <===
CheckWebSite "http://www.brocolli.co.za"
CheckWebSite "http://www.noseweek.co.za"
CheckWebSite "http://www.mweb.co.za"
CheckWebSite "http://www.lancet.co.za"
CheckWebSite "http://www.legalwise.co.za"
CheckWebSite "http://www.mustek.co.za/"
'
'--
IEauto.quit
'--
Set IEauto = Nothing
'--
Wscript.Quit 0
'--- END of script


Sub CheckWebsite( strURL )
'============================================================================
' Check the URL using IE. Measure time to load/not load etc.
'============================================================================
'
Dim strMsg


'--
IEauto.navigate strURL, 4
'--
IEauto.visible = 1
'--
TimeNow = Time
'--
Do while IEauto.busy
	'--
	Wscript.sleep 200
Loop
'
Set objDoc = IEauto.Document
'--
strTitle = objDoc.Title
'-- not necessary
if len(strTitle) = 0 then 
	objDoc.Location.Reload(True)
End if
'
TimeEnd = Time
'--
TimeTaken = DateDiff("s", TimeNow, TimeEnd ) & " Seconds to load."
'--
Select case IEauto.Readystate
    Case 0
    '-- Uninitialised
    strMsg = "Page uninitialised. It took " & TimeTaken

    Case 1
    '-- Loading
    strMsg = "Page still loading... It took " & TimeTaken

    Case 2
    '-- Loaded
    strMsg = "Page loaded. It took " & TimeTaken

    Case 3
    '-- Partially loaded, interactive.
    strMsg = "Page partly loaded. It took " & TimeTaken

    Case 4
    '-- complete. Fully loaded.
    strMsg = "Page fully loaded. It took " & TimeTaken

    Case Else
    '-- Um, what are you doing here?
    strMsg = "Programmer Error!"

End select
'
'-- Page loaded/did not load, results...
'
Dim strText1


If DateDiff("s", TimeNow, TimeEnd ) > 59 Then
	'-- Too long, error message
	strText1 = "Page did not load in less than 1 minute."
Else
	'-- limit text comment to 255 characters, otherwise you overflow the database field.
	strText1 = Left(strMsg & " [" & Left(IEauto.statustext, instr(IEauto.statustext, chr(0)) -1), 254) & "]"
End if

'--
Log2File Now, strURL, IEauto.Readystate, DateDiff("s", TimeNow, TimeEnd ), strText1
'--
WshShell.PopUp strText1, 5,  "Web Page access checker.", 0
'
End Sub


Sub Log2File( dtNow, stringURL, Readystate, strTimeTaken, strComment)
'============================================================================
' Write to csv and database
'============================================================================
'
Dim strRec, objConn, objRS


'--
strRec = Chr(34) & FormatDateTime(dtNow, 2) & " " & FormatDateTime(dtNow, 3) & Chr(34) & "," & _
    Chr(34) & stringURL & Chr(34) & "," & Readystate & "," & _
    strTimeTaken & "," & strComment
'--
WriteToCSVfile( strRec )
'-- The 'FULL' version writes to a MySql server database here.
End sub


Sub WriteToCSVfile( strRecord )
'============================================================
'
'============================================================
'
Const ForAppending = 8
'
Dim objFSO, objTextFile


'Msgbox strRecord, 64, "record"
'--
Set objFSO = CreateObject("Scripting.FileSystemObject")
'--
Set objTextFile = objFSO.OpenTextFile("CheckedURLs.csv", ForAppending, True)
	'--
	objTextFile.WriteLine( strRecord )
'--
objTextFile.Close

'--
End Sub

